// Code generated by informer-gen. DO NOT EDIT.

package internalversion

import (
	time "time"

	security "github.com/openshift/origin/pkg/security/apis/security"
	internalinterfaces "github.com/openshift/origin/pkg/security/generated/informers/internalversion/internalinterfaces"
	internalclientset "github.com/openshift/origin/pkg/security/generated/internalclientset"
	internalversion "github.com/openshift/origin/pkg/security/generated/listers/security/internalversion"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// SecurityContextConstraintsInformer provides access to a shared informer and lister for
// SecurityContextConstraints.
type SecurityContextConstraintsInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() internalversion.SecurityContextConstraintsLister
}

type securityContextConstraintsInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewSecurityContextConstraintsInformer constructs a new informer for SecurityContextConstraints type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewSecurityContextConstraintsInformer(client internalclientset.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredSecurityContextConstraintsInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredSecurityContextConstraintsInformer constructs a new informer for SecurityContextConstraints type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredSecurityContextConstraintsInformer(client internalclientset.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.Security().SecurityContextConstraints().List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.Security().SecurityContextConstraints().Watch(options)
			},
		},
		&security.SecurityContextConstraints{},
		resyncPeriod,
		indexers,
	)
}

func (f *securityContextConstraintsInformer) defaultInformer(client internalclientset.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredSecurityContextConstraintsInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *securityContextConstraintsInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&security.SecurityContextConstraints{}, f.defaultInformer)
}

func (f *securityContextConstraintsInformer) Lister() internalversion.SecurityContextConstraintsLister {
	return internalversion.NewSecurityContextConstraintsLister(f.Informer().GetIndexer())
}
